poj 3278 Catch That Cow 【bfs】

2023-11-29 23:09
文章标签 cow bfs poj catch 3278

本文主要是介绍poj 3278 Catch That Cow 【bfs】,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

Catch That Cow
Time Limit: 2000MS Memory Limit: 65536K
Total Submissions: 52335 Accepted: 16416

Description

Farmer John has been informed of the location of a fugitive cow and wants to catch her immediately. He starts at a point N (0 ≤ N ≤ 100,000) on a number line and the cow is at a point K (0 ≤ K ≤ 100,000) on the same number line. Farmer John has two modes of transportation: walking and teleporting.

* Walking: FJ can move from any point X to the points - 1 or + 1 in a single minute
* Teleporting: FJ can move from any point X to the point 2 × X in a single minute.

If the cow, unaware of its pursuit, does not move at all, how long does it take for Farmer John to retrieve it?

Input

Line 1: Two space-separated integers:  N and  K

Output

Line 1: The least amount of time, in minutes, it takes for Farmer John to catch the fugitive cow.

Sample Input

5 17

Sample Output

4

Hint

The fastest way for Farmer John to reach the fugitive cow is to move along the following path: 5-10-9-18-17, which takes 4 minutes.

简单bfs, 每个状态可以转换成其他三个状态枚举就好了。

原来是打算用spfa, 但是TL了

代码:

#include <cstdio>
#include <cstring>
#include <queue>
#include <algorithm>
#include <vector>
const int M = 1e5+50;
using namespace std;struct node{int x;int step;bool operator < (const node &a) const {return step > a.step;}
};
bool vis[M];int bfs(int n, int k){memset(vis, 0, sizeof(vis));if(n == k) return 0;node st;st.x = n; st.step = 0;priority_queue<node> q;q.push(st);while(!q.empty()){node temp = q.top();q.pop();node cur;cur.step = temp.step+1;cur.x = temp.x+1;if(cur.x == k) return cur.step;if(cur.x < M&&!vis[cur.x]){vis[cur.x] = 1;q.push(cur);}cur.x = temp.x-1;if(cur.x == k) return cur.step;if(cur.x > 0&&cur.x < M&&!vis[cur.x]){vis[cur.x] = 1;q.push(cur);}cur.x = temp.x*2;if(cur.x == k) return cur.step;if(cur.x < M&&!vis[cur.x]){vis[cur.x] = 1;q.push(cur);}}
}int main(){int n, k;while(scanf("%d%d", &n, &k) == 2){printf("%d\n", bfs(n, k));}
}
/*vector <int >map[M*4];
int d[M];
bool vis[M];/*int bfs(int n, int k){memset(vis, 0, sizeof(vis));priority_queue<node >q;node st;st.x = n; st.step = 0;vis[n] = 1;q.push(st);if(n == k) return 0;while(!q.empty()){node temp = q.top();q.pop();node cur;cur.step = temp.step+1;cur.x = temp.x+1;if(cur.x == k) return cur.step;if(cur.x > 0&&cur.x < M){vis[cur.x] = 1; q.push(cur);}cur.x = temp.x-1;if(cur.x == k) return cur.step;if(cur.x > 0&&cur.x < M){vis[cur.x] = 1; q.push(cur);}cur.x = temp.x*2;if(cur.x == k) return cur.step;if(cur.x > 0&&cur.x < M){vis[cur.x] = 1; q.push(cur);}}
}*//*void spfa(int n, int k){memset(vis, 0, sizeof(vis));memset(d, 'a', sizeof(d));queue<int >q;q.push(n);d[n] = 0;vis[n] = 1;while(!q.empty()){int temp = q.front();q.pop();for(int i = 0; i < map[temp].size(); ++ i){if(d[map[temp][i]] > d[temp]+1){d[map[temp][i]] = d[temp]+1;if(!vis[map[temp][i]]){vis[map[temp][i]] = 1;q.push(map[temp][i]);}			}}}
}int main(){int n, k;while(scanf("%d%d", &n, &k) == 2){for(int i = 1; i < M; ++ i){map[i].clear();if(i-1 > 0) map[i].push_back(i-1);if(i+1 < M) map[i].push_back(i+1);if(i*2 < M) map[i].push_back(i*2);}spfa(n, k);//for(int i = 0; i < M; ++ i) vis[i] = 0, map[i].clear();//for()printf("%d\n", d[k]);}return 0;
}*/


这篇关于poj 3278 Catch That Cow 【bfs】的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/434686

相关文章

hdu1254(嵌套bfs,两次bfs)

/*第一次做这种题感觉很有压力,思路还是有点混乱,总是wa,改了好多次才ac的思路:把箱子的移动当做第一层bfs,队列节点要用到当前箱子坐标(x,y),走的次数step,当前人的weizhi(man_x,man_y),要判断人能否将箱子推到某点时要嵌套第二层bfs(人的移动);代码如下:

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 1258 Agri-Net(最小生成树模板代码)

感觉用这题来当模板更适合。 题意就是给你邻接矩阵求最小生成树啦。~ prim代码:效率很高。172k...0ms。 #include<stdio.h>#include<algorithm>using namespace std;const int MaxN = 101;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int n

poj 1287 Networking(prim or kruscal最小生成树)

题意给你点与点间距离,求最小生成树。 注意点是,两点之间可能有不同的路,输入的时候选择最小的,和之前有道最短路WA的题目类似。 prim代码: #include<stdio.h>const int MaxN = 51;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int P;int prim(){bool vis[MaxN];

poj 2349 Arctic Network uva 10369(prim or kruscal最小生成树)

题目很麻烦,因为不熟悉最小生成树的算法调试了好久。 感觉网上的题目解释都没说得很清楚,不适合新手。自己写一个。 题意:给你点的坐标,然后两点间可以有两种方式来通信:第一种是卫星通信,第二种是无线电通信。 卫星通信:任何两个有卫星频道的点间都可以直接建立连接,与点间的距离无关; 无线电通信:两个点之间的距离不能超过D,无线电收发器的功率越大,D越大,越昂贵。 计算无线电收发器D

poj 1502 MPI Maelstrom(单源最短路dijkstra)

题目真是长得头疼,好多生词,给跪。 没啥好说的,英语大水逼。 借助字典尝试翻译了一下,水逼直译求不喷 Description: BIT他们的超级计算机最近交货了。(定语秀了一堆词汇那就省略吧再见) Valentine McKee的研究顾问Jack Swigert,要她来测试一下这个系统。 Valentine告诉Swigert:“因为阿波罗是一个分布式共享内存的机器,所以它的内存访问

uva 10061 How many zero's and how many digits ?(不同进制阶乘末尾几个0)+poj 1401

题意是求在base进制下的 n!的结果有几位数,末尾有几个0。 想起刚开始的时候做的一道10进制下的n阶乘末尾有几个零,以及之前有做过的一道n阶乘的位数。 当时都是在10进制下的。 10进制下的做法是: 1. n阶位数:直接 lg(n!)就是得数的位数。 2. n阶末尾0的个数:由于2 * 5 将会在得数中以0的形式存在,所以计算2或者计算5,由于因子中出现5必然出现2,所以直接一